﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using Infragistics.Excel;

namespace Grid_Excel_Improt_export
{
    /// ***********************************
    /// 
    ///         Petar Monov Monov,
    ///         DS Engineer,
    ///         Infragistics Bulgaria
    ///         
    /// ***********************************

    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        
        public bool HasLetters(string formatsting)
        {
            foreach (char ch in formatsting)
            {
                if (Char.IsLetter(ch))
                {
                    return true;
                }              
            }
            return false;
        }


        private void button1_Click(object sender, EventArgs e)
        {

            string theFile = @"EMPLOYEE_METRICS.xlsx";

            if (File.Exists(theFile))
            {
                //Load the Excel File into the Workbook Object
                Workbook theWorkbook = Workbook.Load(theFile);

                //We will only work with the first Worksheet in the Workbook
                Worksheet theWorksheet = theWorkbook.Worksheets[0];


                //We will place the Excel Data into this DataTable
                DataTable theEmployeeData = new DataTable("MyData");

                int theRowCounter = 0;
                int theCellCounter = 0;

                //Iterate through all Worksheet rows
                foreach (WorksheetRow theWorksheetRow in theWorksheet.Rows)
                {
                    if (theRowCounter == 0)
                    {
                        theCellCounter = 0;
                        //This is the Header Row. We are assuming that the Excel Worksheet's 
                        //first row contains the schema of our soon to be data model. 
                        //We will use this information to build our DataTable's schema
                        foreach (WorksheetCell theWorksheetCell in theWorksheetRow.Cells)
                        {
                            string theCellValue = theWorksheetCell.Value.ToString().Trim();

                            if (theCellValue != string.Empty)
                            {
                                //This is the "Header Row"
                                //Create a DataColumn for each Column taken from the first Worksheet row
                                DataColumn theDataColumn = theEmployeeData.Columns.Add();

                                //Since this is the Header Row, we use the cell value
                                //as the Column Name
                                theDataColumn.ColumnName = theCellValue;

                                //Here we skip to the actual data row (the row below the header row). 
                                //Check if there is nay data. Check if there were any value types set in
                                //Excel (if type is general it is imported as FormattedString) and 
                                //if so we get set them. If one of the requrements isn't met
                                //we use the default string representation
                                if (theWorksheet.Rows[theRowCounter + 1].Cells[theCellCounter].Value != null)
                                {
                                    if (theWorksheet.Rows[theRowCounter + 1].Cells[theCellCounter].Value.GetType() != typeof(FormattedString))
                                    {
                                        // Since both Double and DateTime cells are imported as double values we use the CellFormat 
                                        // to differentiate between them
                                        if (theWorksheet.Rows[theRowCounter + 1].Cells[theCellCounter].Value.GetType() == typeof(double))
                                        {
                                            if (HasLetters(theWorksheet.Rows[theRowCounter + 1].Cells[theCellCounter].CellFormat.FormatString))
                                            {
                                                theDataColumn.DataType = typeof(DateTime);
                                            }
                                            else
                                            {
                                                theDataColumn.DataType =
                                                           theWorksheet.Rows[theRowCounter + 1].Cells[theCellCounter].Value.GetType();
                                            }
                                        }
                                        else
                                        {
                                            theDataColumn.DataType =
                                                       theWorksheet.Rows[theRowCounter + 1].Cells[theCellCounter].Value.GetType();
                                        }
                                    }
                                }
                            }
                            else
                            {
                                break;
                                //Exit the loop so that we do not
                                //traverse all empty Worksheet Cells.
                            }

                            theCellCounter++;
                        }
                    }
                    else
                    //This is the actual data that will populate the data model
                    {
                        // theWorksheet.Rows[theRowCounter + 1].Cells[theCellCounter].Value.GetType();
                        theCellCounter = 0;

                        //Add a new empty data row to our data model        
                        DataRow theDataRow = theEmployeeData.NewRow();

                        //iterate through each current Worksheet cell and populate the new data row.
                        foreach (WorksheetCell theWorksheetCell in theWorksheetRow.Cells)
                        {
                            object theValue = theWorksheet.Rows[theRowCounter].Cells[theCellCounter].Value;

                            if (theValue != null)
                            {
                                // Since both Double and DateTime cells are imported as double values we use the CellFormat 
                                // to differentiate between them and convert if necessary
                                if (theWorksheetCell.Value.GetType() == typeof(double))
                                {
                                    if (HasLetters(theWorksheetCell.CellFormat.FormatString))
                                    {
                                        theDataRow[theCellCounter] = DateTime.FromOADate((double)theValue);
                                    }
                                    else
                                    {
                                        theDataRow[theCellCounter] = theValue;
                                    }
                                }
                                else
                                {
                                    theDataRow[theCellCounter] = theValue;
                                }
                            }
                            else
                            {
                                break;
                                //Exit the loop so that we do not
                                //traverse all empty Worksheet Cells.
                            }

                            theCellCounter++;
                        }

                        //Add the Data Row to the DataTable
                        theEmployeeData.Rows.Add(theDataRow);
                    }

                    theRowCounter++;
                }

                //AcceptChanges so that these do not appear to be NEW rows
                theEmployeeData.AcceptChanges();


                //Finally, bind the WinGrid to the DataTable
                this.ultraGrid1.DataSource = theEmployeeData.DefaultView;
            }
            else
            {
                MessageBox.Show("No such file was found!");
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            ultraGridExcelExporter1.Export(ultraGrid1,"ExportedGrid.xlsx",WorkbookFormat.Excel2007);
            //ultraGridExcelExporter1.Export(ultraGrid1, "ExportedGrid.xls", WorkbookFormat.Excel97To2003);

        }
    }
}
